<?php
/*
 *  builder.php3 - call every builders 
 *
 *  Copyright (C) 2001 STRASSER Michel
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

include("builders/contact.php3");
include("builders/vitrine.php3");
include("builders/links.php3");
include("builders/home.php3");
include("builders/buy_choose.php3");
include("builders/buy_your_command.php3");
include("builders/upgrade.php3");
include("builders/admin.php3");
include("builders/upload.php3");

class builder {

  function builder() {

  }

  function build() {
    global $data_tree, $building_theme;
    
    $theme_name=$data_tree["OTHERS"]["Theme"]["VALUE"] or "default";

    $building_theme=new theme($theme_name);

    contact_build();
    vitrine_build();
    links_build();
    home_build();
    buy_choose_build();
    buy_your_command_build();
    upgrade_build();
    admin_build();
    upload_build();

  }

}


?>
