<?php

/*
 *  compile.php3 - loaded on a submitted config file 
 *
 *  Copyright (C) 2001 STRASSER Michel
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
  include("global.php3");
  include("parser.php3");
  include("builder.php3");
  /* internationalisation */
  $tra_compilation="Compilation";
  $tra_proceding="Results ...";
  $tra_copying_file="Copying file";
  $tra_checking_password="Checking password";
  $tra_analysing_header="Checking file header";
  $tra_checking_file_key="Checking file key";
  $tra_deleting_config_file="Deleting config file";

  //Testing the presence of the file we have to transmit
  if(isset($configuration_file)) {
    $items="";
    if ($given_password==$static_password){
      $items.=$my_theme->check_list_item ($tra_checking_password, true, ""); 
      if (copy($configuration_file, $config_filename)) {
        $items.=$my_theme->check_list_item ($tra_copying_file, true, "");
	$my_file=fopen($config_filename, "r");
	$my_first_line=fgets($my_file, $max_line_size);
	fclose($my_file);
	$my_first_line_array = explode( $separator_character, $my_first_line);
	if ($my_first_line_array[0]=="MIFAIN") {
	  $items.=$my_theme->check_list_item ($tra_analysing_header, true, "");
	  $i=1;
	  while($i<=count($my_first_line_array)) {
	    $a2=explode("=", $my_first_line_array[$i]);
	    $header_hash[$a2[0]]=$a2[1];
            $i++;
	  }
	  if ($header_hash["key"]==$static_key) {
	    $items.=$my_theme->check_list_item ($tra_checking_file_key, true, "");

            // OK, there are no more fatal errors
	    // we can now parse
            
	    $my_parser = new parser();
	    $my_parser->set_config_filename($config_filename);
	    $success=$my_parser->parse();

	    //if parsing has successed, we can build
	    
	    if ($success) {
	      $my_builder = new builder();
	      $my_builder->build();
	    }
	    
	  }
	  else {
	    $items.=$my_theme->check_list_item ($tra_checking_file_key, false, "FATAL ERROR, <br>\n
            File key does not match<br>\n
  	    Are you a cracker ?<br>\n
	    Please contact the site aministrator to know the actual key. <br>\n
	    Crackers, no social enginering, it doesn't work with me !
	    ");
	  }
        }
	else {
	  $items.=$my_theme->check_list_item ($tra_analysing_header, false, "FATAL ERROR, <br>\n
          This file seems not to be a valid configuration file<br>\n
	  I need a csv file with the tabulation character as separator");
	}
      }
      else {
        $items.=$my_theme->check_list_item ($tra_copying_file, false, "FATAL ERROR, <br>\n
          $configuration_file could not be copied into ./ directory <br>\n
	  Does your ISP allows copying files with PHP ? <br>\n
          Does your config file exceed 2 Mega Octets ?");
      }
      if(unlink($config_filename)) {
        $items.=$my_theme->check_list_item ($tra_deleting_config_file, 
		true,""); 
      }
      else {
        $items.=$my_theme->check_list_item ($tra_deleting_config_file, false, 
		"WARNING : failed on deleting the config file<br>
		It may always be on the server, someone else
		could get your MIFAIN secret key.<br>
		Please check, and in that case, delete it manually(by FTP).<br>
		Check the relative permissions for this file : 
		$config_filename");
      }
    }
    else {
      $items.=$my_theme->check_list_item ($tra_checking_password, false, "FATAL ERROR, <br>\n
          passwords not matching<br>\n
	  Are you a cracker ?<br>\n
	  Have you made some errors on typing the passwords ? Try again !"); 
    }
  
    $my_block=$my_theme->check_list($tra_proceding, $items);
  
    $to_write=$my_theme->embed("$tra_compilation", "<center>" . $my_block . "</center>");
    echo ($to_write);

  }
  
?>
